#pragma once

namespace GDIPlusTextWithBrushes
{
	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::Drawing::Drawing2D;

	/// <summary> 
	/// Summary for Form1
	///
	/// WARNING: If you change the name of this class, you will need to change the 
	///          'Resource File Name' property for the managed resource compiler tool 
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public __gc class Form1 : public System::Windows::Forms::Form
	{	
	public:
		Form1(void)
		{
			InitializeComponent();
		}
  
	protected:
		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}

	private: System::Windows::Forms::GroupBox *  groupBox1;

	private: System::Windows::Forms::Label *  label1;
	private: System::Windows::Forms::Label *  label2;
	private: System::Windows::Forms::Button *  btnDisplayText;
	private: System::Windows::Forms::NumericUpDown *  spnFontSize;
	private: System::Windows::Forms::RadioButton *  rbtnGradient;
	private: System::Windows::Forms::RadioButton *  rbtnHatch;
	private: System::Windows::Forms::TextBox *  txtToDisplay;
	private: System::Windows::Forms::Button *  btnClose;

	private: System::Windows::Forms::PictureBox *  picText;



	private: System::Windows::Forms::ComboBox *  cbxPrimaryColour;
	private: System::Windows::Forms::ComboBox *  cbxSecondaryColour;
	private: System::Windows::Forms::Button *  btnContactMe;
	private: System::Windows::Forms::Button *  btnArticleList;
	private: System::Windows::Forms::Label *  label4;
	private: System::Windows::Forms::Label *  label5;

	public:
		__value enum TextStyle
		{
			Hatch,
			Gradient
		};
		
	protected:
		String* textToDisplay;
		Decimal fontSize;
		TextStyle style;
		Color primaryColour;
		Color secondaryColour;

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container * components;

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->btnDisplayText = new System::Windows::Forms::Button();
			this->groupBox1 = new System::Windows::Forms::GroupBox();
			this->label4 = new System::Windows::Forms::Label();
			this->label5 = new System::Windows::Forms::Label();
			this->cbxPrimaryColour = new System::Windows::Forms::ComboBox();
			this->cbxSecondaryColour = new System::Windows::Forms::ComboBox();
			this->spnFontSize = new System::Windows::Forms::NumericUpDown();
			this->rbtnGradient = new System::Windows::Forms::RadioButton();
			this->rbtnHatch = new System::Windows::Forms::RadioButton();
			this->txtToDisplay = new System::Windows::Forms::TextBox();
			this->label1 = new System::Windows::Forms::Label();
			this->label2 = new System::Windows::Forms::Label();
			this->btnClose = new System::Windows::Forms::Button();
			this->picText = new System::Windows::Forms::PictureBox();
			this->btnContactMe = new System::Windows::Forms::Button();
			this->btnArticleList = new System::Windows::Forms::Button();
			this->groupBox1->SuspendLayout();
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->spnFontSize))->BeginInit();
			this->SuspendLayout();
			// 
			// btnDisplayText
			// 
			this->btnDisplayText->Location = System::Drawing::Point(344, 152);
			this->btnDisplayText->Name = S"btnDisplayText";
			this->btnDisplayText->Size = System::Drawing::Size(80, 23);
			this->btnDisplayText->TabIndex = 1;
			this->btnDisplayText->Text = S"Display &Text";
			this->btnDisplayText->Click += new System::EventHandler(this, btnDisplayText_Click);
			// 
			// groupBox1
			// 
			this->groupBox1->Controls->Add(this->label4);
			this->groupBox1->Controls->Add(this->label5);
			this->groupBox1->Controls->Add(this->cbxPrimaryColour);
			this->groupBox1->Controls->Add(this->cbxSecondaryColour);
			this->groupBox1->Controls->Add(this->spnFontSize);
			this->groupBox1->Controls->Add(this->rbtnGradient);
			this->groupBox1->Controls->Add(this->rbtnHatch);
			this->groupBox1->Controls->Add(this->txtToDisplay);
			this->groupBox1->Controls->Add(this->label1);
			this->groupBox1->Controls->Add(this->label2);
			this->groupBox1->Location = System::Drawing::Point(8, 8);
			this->groupBox1->Name = S"groupBox1";
			this->groupBox1->Size = System::Drawing::Size(320, 136);
			this->groupBox1->TabIndex = 0;
			this->groupBox1->TabStop = false;
			this->groupBox1->Text = S"Display Settings";
			// 
			// label4
			// 
			this->label4->Location = System::Drawing::Point(16, 88);
			this->label4->Name = S"label4";
			this->label4->Size = System::Drawing::Size(136, 16);
			this->label4->TabIndex = 11;
			this->label4->Text = S"Primary colour:";
			this->label4->TextAlign = System::Drawing::ContentAlignment::BottomLeft;
			// 
			// label5
			// 
			this->label5->Location = System::Drawing::Point(176, 88);
			this->label5->Name = S"label5";
			this->label5->Size = System::Drawing::Size(128, 16);
			this->label5->TabIndex = 12;
			this->label5->Text = S"Secondary colour:";
			this->label5->TextAlign = System::Drawing::ContentAlignment::BottomLeft;
			// 
			// cbxPrimaryColour
			// 
			this->cbxPrimaryColour->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cbxPrimaryColour->Location = System::Drawing::Point(16, 104);
			this->cbxPrimaryColour->Name = S"cbxPrimaryColour";
			this->cbxPrimaryColour->Size = System::Drawing::Size(136, 21);
			this->cbxPrimaryColour->TabIndex = 10;
			// 
			// cbxSecondaryColour
			// 
			this->cbxSecondaryColour->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->cbxSecondaryColour->Location = System::Drawing::Point(176, 104);
			this->cbxSecondaryColour->Name = S"cbxSecondaryColour";
			this->cbxSecondaryColour->Size = System::Drawing::Size(128, 21);
			this->cbxSecondaryColour->TabIndex = 8;
			// 
			// spnFontSize
			// 
			this->spnFontSize->Location = System::Drawing::Point(80, 56);
			this->spnFontSize->Name = S"spnFontSize";
			this->spnFontSize->Size = System::Drawing::Size(48, 20);
			this->spnFontSize->TabIndex = 3;
			System::Int32 __mcTemp__1[] = new System::Int32[4];
			__mcTemp__1[0] = 40;
			__mcTemp__1[1] = 0;
			__mcTemp__1[2] = 0;
			__mcTemp__1[3] = 0;
			this->spnFontSize->Value = System::Decimal(__mcTemp__1);
			// 
			// rbtnGradient
			// 
			this->rbtnGradient->Checked = true;
			this->rbtnGradient->Location = System::Drawing::Point(232, 56);
			this->rbtnGradient->Name = S"rbtnGradient";
			this->rbtnGradient->Size = System::Drawing::Size(72, 24);
			this->rbtnGradient->TabIndex = 5;
			this->rbtnGradient->TabStop = true;
			this->rbtnGradient->Text = S"&Gradient";
			this->rbtnGradient->TextAlign = System::Drawing::ContentAlignment::MiddleRight;
			// 
			// rbtnHatch
			// 
			this->rbtnHatch->Location = System::Drawing::Point(168, 56);
			this->rbtnHatch->Name = S"rbtnHatch";
			this->rbtnHatch->Size = System::Drawing::Size(56, 24);
			this->rbtnHatch->TabIndex = 4;
			this->rbtnHatch->Text = S"&Hatch";
			this->rbtnHatch->TextAlign = System::Drawing::ContentAlignment::MiddleRight;
			// 
			// txtToDisplay
			// 
			this->txtToDisplay->Location = System::Drawing::Point(80, 24);
			this->txtToDisplay->Name = S"txtToDisplay";
			this->txtToDisplay->Size = System::Drawing::Size(224, 20);
			this->txtToDisplay->TabIndex = 1;
			this->txtToDisplay->Text = S"Tom Archer";
			// 
			// label1
			// 
			this->label1->Location = System::Drawing::Point(16, 24);
			this->label1->Name = S"label1";
			this->label1->Size = System::Drawing::Size(56, 23);
			this->label1->TabIndex = 0;
			this->label1->Text = S"Te&xt:";
			this->label1->TextAlign = System::Drawing::ContentAlignment::MiddleRight;
			// 
			// label2
			// 
			this->label2->Location = System::Drawing::Point(16, 56);
			this->label2->Name = S"label2";
			this->label2->Size = System::Drawing::Size(56, 23);
			this->label2->TabIndex = 2;
			this->label2->Text = S"&Font Size:";
			this->label2->TextAlign = System::Drawing::ContentAlignment::MiddleRight;
			// 
			// btnClose
			// 
			this->btnClose->DialogResult = System::Windows::Forms::DialogResult::Cancel;
			this->btnClose->Location = System::Drawing::Point(344, 16);
			this->btnClose->Name = S"btnClose";
			this->btnClose->Size = System::Drawing::Size(80, 23);
			this->btnClose->TabIndex = 2;
			this->btnClose->Text = S"Cl&ose";
			this->btnClose->Click += new System::EventHandler(this, btnClose_Click);
			// 
			// picText
			// 
			this->picText->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->picText->Location = System::Drawing::Point(8, 152);
			this->picText->Name = S"picText";
			this->picText->Size = System::Drawing::Size(320, 104);
			this->picText->TabIndex = 4;
			this->picText->TabStop = false;
			this->picText->Paint += new System::Windows::Forms::PaintEventHandler(this, picText_Paint);
			// 
			// btnContactMe
			// 
			this->btnContactMe->Location = System::Drawing::Point(344, 48);
			this->btnContactMe->Name = S"btnContactMe";
			this->btnContactMe->Size = System::Drawing::Size(80, 23);
			this->btnContactMe->TabIndex = 3;
			this->btnContactMe->Text = S"Contact &Me";
			this->btnContactMe->Click += new System::EventHandler(this, btnContactMe_Click);
			// 
			// btnArticleList
			// 
			this->btnArticleList->Location = System::Drawing::Point(344, 72);
			this->btnArticleList->Name = S"btnArticleList";
			this->btnArticleList->Size = System::Drawing::Size(80, 23);
			this->btnArticleList->TabIndex = 5;
			this->btnArticleList->Text = S"Article &List";
			this->btnArticleList->Click += new System::EventHandler(this, btnArticleList_Click);
			// 
			// Form1
			// 
			this->AutoScaleBaseSize = System::Drawing::Size(5, 13);
			this->CancelButton = this->btnClose;
			this->ClientSize = System::Drawing::Size(432, 259);
			this->Controls->Add(this->btnArticleList);
			this->Controls->Add(this->picText);
			this->Controls->Add(this->btnContactMe);
			this->Controls->Add(this->btnClose);
			this->Controls->Add(this->groupBox1);
			this->Controls->Add(this->btnDisplayText);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::Fixed3D;
			this->MaximizeBox = false;
			this->Name = S"Form1";
			this->Text = S"Managed Extensions - Using GDI+ to Draw Text with Brushes";
			this->Load += new System::EventHandler(this, Form1_Load);
			this->groupBox1->ResumeLayout(false);
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->spnFontSize))->EndInit();
			this->ResumeLayout(false);

		}	

		private: System::Void Form1_Load(System::Object *  sender, System::EventArgs *  e)
		{
			for (int i = 1; i < 168; i++)
			{
				this->cbxSecondaryColour->Items->Add(__box(Color::FromKnownColor( (KnownColor)(i) )));
				this->cbxPrimaryColour->Items->Add(__box(Color::FromKnownColor( (KnownColor)(i) )));
			}
			this->cbxPrimaryColour->SelectedIndex=33;
			this->cbxSecondaryColour->SelectedIndex=34;
		}

		private: System::Void btnContactMe_Click(System::Object *  sender, System::EventArgs *  e)
		{
			System::Diagnostics::Process::Start(S"IExplore.exe", S"http://www.ArcherConsultingGroup.com/default.asp?id=1006");
		}

		private: System::Void btnArticleList_Click(System::Object *  sender, System::EventArgs *  e)
		{
			System::Diagnostics::Process::Start(S"IExplore.exe", S"http://www.codeguru.com/columns/DotNetTips");
		}

		private: System::Void btnClose_Click(System::Object *  sender, System::EventArgs *  e)
		{ this->Close(); }

		private: System::Void btnDisplayText_Click(System::Object *  sender, System::EventArgs *  e)
		{
			textToDisplay = txtToDisplay->Text;
			fontSize = spnFontSize->Value;

			if (rbtnGradient->Checked) style = TextStyle::Gradient;
			else if (rbtnHatch->Checked) style = TextStyle::Hatch;

			primaryColour = Color::FromKnownColor( (KnownColor)(cbxPrimaryColour->SelectedIndex+1));
			secondaryColour = Color::FromKnownColor( (KnownColor)(cbxSecondaryColour->SelectedIndex+1));

			picText->Invalidate();
		}

		private: System::Void picText_Paint(System::Object *  sender, System::Windows::Forms::PaintEventArgs *  e)
		{
			if (textToDisplay)
			{
				// Obtain the Graphics object
				Graphics* g = e->Graphics; 

				// Create the font that will be used.
				System::Drawing::Font* font = 
					new System::Drawing::Font(S"Times New Roman", 
																		Convert::ToSingle(fontSize), 
																											FontStyle::Regular);

				// Measure the user-supplied text
				SizeF textSize = g->MeasureString(textToDisplay, font);

				// Create the GDI+ brush
				Brush* brush;
				if (TextStyle::Hatch == style)  // if the user selected Hatch 
				{
					// GDI+ supplies a HatchBrush object. 
					// I'm using the built-in "cross hatch" pattern
					brush = new HatchBrush(HatchStyle::Cross,
																primaryColour,
																secondaryColour);
				}
				else if (TextStyle::Gradient == style) // if the user selected Gradient
				{
					// Instantiate a LinearGradientBrush object. 
					// I'm using the built-in "forward-diagonal" gradient
					RectangleF* rect = __nogc new RectangleF(PointF(0, 0), textSize);
					brush = new LinearGradientBrush(*rect, 
																					primaryColour,
																					secondaryColour,
																					LinearGradientMode::ForwardDiagonal);
				}

				// Clear the picture box using a white background so that 
				// the gradient and hatch text shows up best
				g->Clear(Color::White);

				// Now that we have a brush, simply draw the text using DrawString!!
				g->DrawString(textToDisplay, 
											font, 
											brush,
											(picText->Width - textSize.Width) / 2,
											(picText->Height - textSize.Height) / 2);
			}
		}
	};
}
